#ifndef GM_FUNCTION_PROXY_H
#define GM_FUNCTION_PROXY_H

#pragma warning( disable: 4127 )

//class _DUMMY_{};
//attention avant ct class CLASS = _DUMMY_ => si ca marche pas avc void, reverse mais si ca marche, supprimer class _DUMMY_
template<int ProxyType, bool isConstFunction, int NumParam, class CLASS = void, typename FUNCTION = void*, typename RET = void, typename P1 = void, typename P2 = void, typename P3 = void, typename P4 = void, typename P5 = void, typename P6 = void, typename P7 = void, typename P8 = void, typename P9 = void, typename P10 = void> class gmFuncProxy : public gmProxy
{
public:
	gmFuncProxy( FUNCTION pFunc )
	{
		this->pFunc = pFunc;

		for( int i = 0; i < NumParam+2; ++i )
			GmType[i] = GM_UNKNOWN;
	}

	gmVariable operator()(gmThread* pThread, void* pObj) const
	{
		gmVariable Result = gmVariable::s_null;

		if( pThread )
		{
			int ParamNumber = pThread->GetNumParams();

			if( ProxyType == METHODE_OPERATOR_TYPE )
			{
				if( ParamNumber < 3 )
					--ParamNumber;
				else
					ParamNumber = 1; //cas special pour O_SETIND
			}

			GM_ASSERT( ParamNumber == NumParam );

			switch( ParamNumber )
			{
			case 0:
				Result = SWITCH< NumParam == 0 ? ( ( ProxyType != FUNCTION_OPERATOR_TYPE ) ?  ProxyType : FUNCTION_TYPE ) : 0 >::Call0Param<CLASS,RET,FUNCTION>( pFunc, (CLASS*)pObj, pThread, GmType ); break;
			
			case 1:
				Result = SWITCH< NumParam == 1 ? ( ( ProxyType != FUNCTION_OPERATOR_TYPE ) ?  ProxyType : FUNCTION_TYPE ) : 0 >::Call1Param<CLASS,RET,P1,FUNCTION>( pFunc, (CLASS*)pObj, pThread, GmType ); break;

			case 2:
				Result = SWITCH< NumParam == 2 ? ( ( ProxyType != FUNCTION_OPERATOR_TYPE ) ?  ProxyType : FUNCTION_TYPE ) : 0 >::Call2Param<CLASS,RET,P1,P2,FUNCTION>( pFunc, (CLASS*)pObj, pThread, GmType ); break;

			case 3:
				Result = SWITCH< NumParam == 3 ? ( ( ProxyType != FUNCTION_OPERATOR_TYPE ) ?  ProxyType : FUNCTION_TYPE ) : 0 >::Call3Param<CLASS,RET,P1,P2,P3,FUNCTION>( pFunc, (CLASS*)pObj, pThread, GmType ); break;

			case 4:
				Result = SWITCH< NumParam == 4 ? ( ( ProxyType != FUNCTION_OPERATOR_TYPE ) ?  ProxyType : FUNCTION_TYPE ) : 0 >::Call4Param<CLASS,RET,P1,P2,P3,P4,FUNCTION>( pFunc, (CLASS*)pObj, pThread, GmType ); break;
			
			case 5:
				Result = SWITCH< NumParam == 5 ? ( ( ProxyType != FUNCTION_OPERATOR_TYPE ) ?  ProxyType : FUNCTION_TYPE ) : 0 >::Call5Param<CLASS,RET,P1,P2,P3,P4,P5,FUNCTION>( pFunc, (CLASS*)pObj, pThread, GmType ); break;
			
			case 6:
				Result = SWITCH< NumParam == 6 ? ( ( ProxyType != FUNCTION_OPERATOR_TYPE ) ?  ProxyType : FUNCTION_TYPE ) : 0 >::Call6Param<CLASS,RET,P1,P2,P3,P4,P5,P6,FUNCTION>( pFunc, (CLASS*)pObj, pThread, GmType ); break;
			
			case 7:
				Result = SWITCH< NumParam == 7 ? ( ( ProxyType != FUNCTION_OPERATOR_TYPE ) ?  ProxyType : FUNCTION_TYPE ) : 0 >::Call7Param<CLASS,RET,P1,P2,P3,P4,P5,P6,P7,FUNCTION>( pFunc, (CLASS*)pObj, pThread, GmType ); break;
			
			case 8:
				Result = SWITCH< NumParam == 8 ? ( ( ProxyType != FUNCTION_OPERATOR_TYPE ) ?  ProxyType : FUNCTION_TYPE ) : 0 >::Call8Param<CLASS,RET,P1,P2,P3,P4,P5,P6,P7,P8,FUNCTION>( pFunc, (CLASS*)pObj, pThread, GmType ); break;

			case 9:
				Result = SWITCH< NumParam == 9 ? ( ( ProxyType != FUNCTION_OPERATOR_TYPE ) ?  ProxyType : FUNCTION_TYPE ) : 0 >::Call9Param<CLASS,RET,P1,P2,P3,P4,P5,P6,P7,P8,P9,FUNCTION>( pFunc, (CLASS*)pObj, pThread, GmType ); break;

			case 10:
				Result = SWITCH< NumParam == 10 ? ( ( ProxyType != FUNCTION_OPERATOR_TYPE ) ?  ProxyType : FUNCTION_TYPE ) : 0 >::Call10Param<CLASS,RET,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10,FUNCTION>( pFunc, (CLASS*)pObj, pThread, GmType ); break;
			}
		}

		return Result;
	}

	int CompareTypes( gmType Type, int ParamNumber ) const //correspond exactement => 3         conversion possible => 2         conversion possible mais pas terrible  => 1
		//ne pas oublier d'ajuster gmVariableProxy egalement
	{
		if( ParamNumber <= NumParam )
		{
			gmType ParamType = GmType[2+ ParamNumber];

			if( ParamType > 0 )
			{
				if( Type == ParamType )
					return 3;
			}
			else
			{
				if( Type == -ParamType )
					return 3;
			}

			switch( Type )
			{
			case GM_NULL:
				return 0;

			case GM_INT:
				{
					if( ParamType == GM_FLOAT )
						return 2;
					else if( ParamType == GM_STRING || ParamType == GM_C_STRING || ParamType == GM_CONST_C_STRING )
						return 1;

				} break;

			case GM_FLOAT:
				{
					if( ParamType == GM_INT )
						return 2;
					else if( ParamType == GM_STRING || ParamType == GM_C_STRING || ParamType == GM_CONST_C_STRING )
						return 1;

				} break;

			case GM_STRING:
				{
					if( ParamType == GM_C_STRING || ParamType == GM_CONST_C_STRING )
						return 2;
					else if( ParamType == GM_INT || ParamType == GM_FLOAT )
						return 1;

				} break;

	
			case GM_CONST_C_STRING:
			case GM_C_STRING:
				{
					if( ParamType == GM_STRING )
						return 2;
					else if( ParamType == GM_INT || ParamType == GM_FLOAT )
						return 1;					

				} break;
				
			case GM_TABLE:
			case GM_FUNCTION:
				{
					if( ParamType == GM_ANY_PTR || ParamType == GM_CONST_ANY_PTR )
						return 1;

				} break;
			
			default:
				{
					if( Type % 2 ) //Type est non const ptr
					{
						if( ParamType == Type+1 )
							return 3;
						else if( ParamType == GM_ANY_PTR || ParamType == GM_CONST_ANY_PTR )
							return 1;
					}
					else //Type est const ptr
					{
						if( ParamType == -(Type-1) ) //le parametre est de type obj pass par valeur(copie)
							return 3;
						else if( ParamType == GM_CONST_ANY_PTR )
							return 1;
						else if( ParamType == GM_ANY_PTR || ParamType == Type-1 )
							return 0;
					}

					std::map<const gmType,gmClassDef*>::const_iterator i = gmMachineEx::ClassList.find( Type );
					if( i != gmMachineEx::ClassList.end() )
					{
						std::map<const gmType,gmClassDef*>::const_iterator j = gmMachineEx::ClassList.find( ParamType );

						if( j != gmMachineEx::ClassList.end() )
						{
							if( i->second->Base == j->second )
								return 2;
						}

					}
				}
			}
		}
		
		return 0;
	}

	int GetProxyType() const { return ProxyType; }
	bool isConst() const { return isConstFunction; }
	void UpdateTypes();

private:
	FUNCTION pFunc;
	gmType GmType[1+1+NumParam]; //Class,Ret,Params
};

template<int ProxyType, bool isConstFunction, int NumParam, class CLASS, typename FUNCTION, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10> void gmFuncProxy<ProxyType,isConstFunction,NumParam,CLASS,FUNCTION,RET,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10>::UpdateTypes()
{
	if( GmType[0] == GM_UNKNOWN ) GmType[0] = GetTypeId<CLASS>();
	if( GmType[1] == GM_UNKNOWN ) GmType[1] = ( GET<RET>::Type < GM_USER && GET<RET>::Type >= GM_NULL ) ? GET<RET>::Type : GetTypeId<RET>();

	if( NumParam > 0 && GmType[2]  == GM_UNKNOWN ) GmType[2]  = ( GET<P1>::Type < GM_USER && GET<P1>::Type >= GM_NULL ) ? GET<P1>::Type : GetTypeId<P1>();
	if( NumParam > 1 && GmType[3]  == GM_UNKNOWN ) GmType[3]  = ( GET<P2>::Type < GM_USER && GET<P2>::Type >= GM_NULL ) ? GET<P2>::Type : GetTypeId<P2>();
	if( NumParam > 2 && GmType[4]  == GM_UNKNOWN ) GmType[4]  = ( GET<P3>::Type < GM_USER && GET<P3>::Type >= GM_NULL ) ? GET<P3>::Type : GetTypeId<P3>();
	if( NumParam > 3 && GmType[5]  == GM_UNKNOWN ) GmType[5]  = ( GET<P4>::Type < GM_USER && GET<P4>::Type >= GM_NULL ) ? GET<P4>::Type : GetTypeId<P4>();
	if( NumParam > 4 && GmType[6]  == GM_UNKNOWN ) GmType[6]  = ( GET<P5>::Type < GM_USER && GET<P5>::Type >= GM_NULL ) ? GET<P5>::Type : GetTypeId<P5>();
	if( NumParam > 5 && GmType[7]  == GM_UNKNOWN ) GmType[7]  = ( GET<P6>::Type < GM_USER && GET<P6>::Type >= GM_NULL ) ? GET<P6>::Type : GetTypeId<P6>();
	if( NumParam > 6 && GmType[8]  == GM_UNKNOWN ) GmType[8]  = ( GET<P7>::Type < GM_USER && GET<P7>::Type >= GM_NULL ) ? GET<P7>::Type : GetTypeId<P7>();
	if( NumParam > 7 && GmType[9]  == GM_UNKNOWN ) GmType[9]  = ( GET<P8>::Type < GM_USER && GET<P8>::Type >= GM_NULL ) ? GET<P8>::Type : GetTypeId<P8>();
	if( NumParam > 8 && GmType[10] == GM_UNKNOWN ) GmType[10] = ( GET<P9>::Type < GM_USER && GET<P9>::Type >= GM_NULL ) ? GET<P9>::Type : GetTypeId<P9>();
	if( NumParam > 9 && GmType[11] == GM_UNKNOWN ) GmType[11] = ( GET<P10>::Type < GM_USER && GET<P10>::Type >= GM_NULL ) ? GET<RET>::Type : GetTypeId<RET>();

	if( NumParam > 0 && GmType[2] % 2 && ADJUST<P1>::isObj ) GmType[2] = -GmType[2]; //Si GmType % 2 retourne 1 => non const ptr 
	if( NumParam > 1 && GmType[3] % 2 && ADJUST<P2>::isObj ) GmType[3] = -GmType[3];
	if( NumParam > 2 && GmType[4] % 2 && ADJUST<P3>::isObj ) GmType[4] = -GmType[4];
	if( NumParam > 3 && GmType[5] % 2 && ADJUST<P4>::isObj ) GmType[5] = -GmType[5];
	if( NumParam > 4 && GmType[6] % 2 && ADJUST<P5>::isObj ) GmType[6] = -GmType[6];
	if( NumParam > 5 && GmType[7] % 2 && ADJUST<P6>::isObj ) GmType[7] = -GmType[7];
	if( NumParam > 2 && GmType[8] % 2 && ADJUST<P7>::isObj ) GmType[4] = -GmType[4];
	if( NumParam > 3 && GmType[9] % 2 && ADJUST<P8>::isObj ) GmType[5] = -GmType[5];
	if( NumParam > 4 && GmType[10] % 2 && ADJUST<P9>::isObj ) GmType[6] = -GmType[6];
	if( NumParam > 5 && GmType[11] % 2 && ADJUST<P10>::isObj ) GmType[7] = -GmType[7];
}


template<typename FUNCTION> inline gmProxy* CreateFunctionProxy( FUNCTION pFunc )	{ return _CreateFunctionProxy(pFunc); }
template<typename METHODE>  inline gmProxy* CreateMethodeProxy ( METHODE pMeth )	{ return _CreateMethodeProxy(pMeth); }
template<typename OPERATOR> inline gmProxy* CreateOperatorProxy( OPERATOR pOp )		{ return _CreateOperatorProxy(pOp); }

template<typename RET> inline gmProxy* _CreateFunctionProxy( RET (__cdecl* pFunc)() )		{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,0,_DUMMY_, RET(__cdecl*)() ,RET>( pFunc );	}
template<typename RET> inline gmProxy* _CreateFunctionProxy( RET (__stdcall* pFunc)() )		{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,0,_DUMMY_, RET(__stdcall*)() ,RET>( pFunc ); }

template<typename RET, typename P1> inline gmProxy* _CreateFunctionProxy( RET (__cdecl* pFunc)(P1) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,1,_DUMMY_, RET(__cdecl*)(P1) ,RET,P1>( pFunc ); }
template<typename RET, typename P1> inline gmProxy* _CreateFunctionProxy( RET (__stdcall* pFunc)(P1) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,1,_DUMMY_, RET(__stdcall*)(P1) ,RET,P1>( pFunc ); }

template<typename RET, typename P1, typename P2> inline gmProxy* _CreateFunctionProxy( RET (__cdecl* pFunc)(P1,P2) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,2,_DUMMY_, RET(__cdecl*)(P1,P2), RET,P1,P2>( pFunc ); }
template<typename RET, typename P1, typename P2> inline gmProxy* _CreateFunctionProxy( RET (__stdcall* pFunc)(P1,P2) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,2,_DUMMY_, RET(__stdcall*)(P1,P2), RET,P1,P2>( pFunc ); }

template<typename RET, typename P1, typename P2, typename P3> inline gmProxy* _CreateFunctionProxy( RET (__cdecl* pFunc)(P1,P2,P3) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,3,_DUMMY_, RET(__cdecl*)(P1,P2,P3),	RET,P1,P2,P3>( pFunc );	}
template<typename RET, typename P1, typename P2, typename P3> inline gmProxy* _CreateFunctionProxy( RET (__stdcall* pFunc)(P1,P2,P3) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,3,_DUMMY_, RET(__stdcall*)(P1,P2,P3), RET,P1,P2,P3>( pFunc ); }

template<typename RET, typename P1, typename P2, typename P3, typename P4> inline gmProxy* _CreateFunctionProxy( RET (__cdecl* pFunc)(P1,P2,P3,P4) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,4,_DUMMY_, RET(__cdecl*)(P1,P2,P3,P4), RET,P1,P2,P3,P4>( pFunc ); }
template<typename RET, typename P1, typename P2, typename P3, typename P4> inline gmProxy* _CreateFunctionProxy( RET (__stdcall* pFunc)(P1,P2,P3,P4) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,4,_DUMMY_, RET(__stdcall*)(P1,P2,P3,P4), RET,P1,P2,P3,P4>( pFunc );	}

template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5> inline gmProxy* _CreateFunctionProxy( RET (__cdecl* pFunc)(P1,P2,P3,P4,P5) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,5,_DUMMY_, RET(__cdecl*)(P1,P2,P3,P4,P5), RET,P1,P2,P3,P4,P5>( pFunc ); }
template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5> inline gmProxy* _CreateFunctionProxy( RET (__stdcall* pFunc)(P1,P2,P3,P4,P5) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,5,_DUMMY_, RET(__stdcall*)(P1,P2,P3,P4,P5), RET,P1,P2,P3,P4,P5>( pFunc ); }

template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6> inline gmProxy* _CreateFunctionProxy( RET (__cdecl* pFunc)(P1,P2,P3,P4,P5,P6) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,6,_DUMMY_, RET(__cdecl*)(P1,P2,P3,P4,P5,P6), RET,P1,P2,P3,P4,P5,P6>( pFunc ); }
template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6> inline gmProxy* _CreateFunctionProxy( RET (__stdcall* pFunc)(P1,P2,P3,P4,P5,P6) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,6,_DUMMY_, RET(__stdcall*)(P1,P2,P3,P4,P5,P6), RET,P1,P2,P3,P4,P5,P6>( pFunc ); }

template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7> inline gmProxy* _CreateFunctionProxy( RET (__cdecl* pFunc)(P1,P2,P3,P4,P5,P6,P7) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,7,_DUMMY_, RET(__cdecl*)(P1,P2,P3,P4,P5,P6,P7), RET,P1,P2,P3,P4,P5,P6,P7>( pFunc ); }
template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7> inline gmProxy* _CreateFunctionProxy( RET (__stdcall* pFunc)(P1,P2,P3,P4,P5,P6,P7) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,7,_DUMMY_, RET(__stdcall*)(P1,P2,P3,P4,P5,P6,P7), RET,P1,P2,P3,P4,P5,P6,P7>( pFunc ); }

template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8> inline gmProxy* _CreateFunctionProxy( RET (__cdecl* pFunc)(P1,P2,P3,P4,P5,P6,P7,P8) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,8,_DUMMY_, RET(__cdecl*)(P1,P2,P3,P4,P5,P6,P7,P8), RET,P1,P2,P3,P4,P5,P6,P7,P8>( pFunc ); }
template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8> inline gmProxy* _CreateFunctionProxy( RET (__stdcall* pFunc)(P1,P2,P3,P4,P5,P6,P7,P8) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,8,_DUMMY_, RET(__stdcall*)(P1,P2,P3,P4,P5,P6,P7,P8), RET,P1,P2,P3,P4,P5,P6,P7,P8>( pFunc ); }

template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9> inline gmProxy* _CreateFunctionProxy( RET (__cdecl* pFunc)(P1,P2,P3,P4,P5,P6,P7,P8,P9) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,9,_DUMMY_, RET(__cdecl*)(P1,P2,P3,P4,P5,P6,P7,P8,P9), RET,P1,P2,P3,P4,P5,P6,P7,P8,P9>( pFunc ); }
template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9> inline gmProxy* _CreateFunctionProxy( RET (__stdcall* pFunc)(P1,P2,P3,P4,P5,P6,P7,P8,P9) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,9,_DUMMY_, RET(__stdcall*)(P1,P2,P3,P4,P5,P6,P7,P8,P9), RET,P1,P2,P3,P4,P5,P6,P7,P8,P9>( pFunc ); }

template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10> inline gmProxy* _CreateFunctionProxy( RET (__cdecl* pFunc)(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) )		{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,10,_DUMMY_, RET(__cdecl*)(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10), RET,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10>( pFunc ); }
template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10> inline gmProxy* _CreateFunctionProxy( RET (__stdcall* pFunc)(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) )	{ return new gmFuncProxy<FUNCTION_TYPE,IS_NOT_CONST,10,_DUMMY_, RET(__stdcall*)(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10), RET,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10>( pFunc ); }

template<class CLASS, typename RET> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)() )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,0,CLASS, RET(__cdecl    CLASS::*)(), RET>( pMeth ); }
template<class CLASS, typename RET> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)() )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,0,CLASS, RET(__stdcall  CLASS::*)(), RET>( pMeth ); }
template<class CLASS, typename RET> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)() )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,0,CLASS, RET(__thiscall CLASS::*)(), RET>( pMeth ); }

template<class CLASS, typename RET> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)() const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,0,CLASS, RET(__cdecl    CLASS::*)() const, RET>( pMeth ); }
template<class CLASS, typename RET> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)() const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,0,CLASS, RET(__stdcall  CLASS::*)() const, RET>( pMeth ); }
template<class CLASS, typename RET> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)() const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,0,CLASS, RET(__thiscall CLASS::*)() const, RET>( pMeth ); }

template<class CLASS, typename RET, typename P1> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,1,CLASS, RET(__cdecl    CLASS::*)(P1), RET,P1>( pMeth ); }
template<class CLASS, typename RET, typename P1> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,1,CLASS, RET(__stdcall  CLASS::*)(P1), RET,P1>( pMeth ); }
template<class CLASS, typename RET, typename P1> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,1,CLASS, RET(__thiscall CLASS::*)(P1), RET,P1>( pMeth ); }

template<class CLASS, typename RET, typename P1> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,1,CLASS, RET(__cdecl    CLASS::*)(P1) const, RET,P1>( pMeth ); }
template<class CLASS, typename RET, typename P1> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,1,CLASS, RET(__stdcall  CLASS::*)(P1) const, RET,P1>( pMeth ); }
template<class CLASS, typename RET, typename P1> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,1,CLASS, RET(__thiscall CLASS::*)(P1) const, RET,P1>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,2,CLASS, RET(__cdecl    CLASS::*)(P1,P2), RET,P1,P2>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,2,CLASS, RET(__stdcall  CLASS::*)(P1,P2), RET,P1,P2>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,2,CLASS, RET(__thiscall CLASS::*)(P1,P2), RET,P1,P2>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,2,CLASS, RET(__cdecl    CLASS::*)(P1,P2) const, RET,P1,P2>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,2,CLASS, RET(__stdcall  CLASS::*)(P1,P2) const, RET,P1,P2>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,2,CLASS, RET(__thiscall CLASS::*)(P1,P2) const, RET,P1,P2>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2, typename P3> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2,P3) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,3,CLASS, RET(__cdecl    CLASS::*)(P1,P2,P3), RET,P1,P2,P3>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2,P3) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,3,CLASS, RET(__stdcall  CLASS::*)(P1,P2,P3), RET,P1,P2,P3>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2,P3) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,3,CLASS, RET(__thiscall CLASS::*)(P1,P2,P3), RET,P1,P2,P3>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2, typename P3> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2,P3) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,3,CLASS, RET(__cdecl    CLASS::*)(P1,P2,P3) const, RET,P1,P2,P3>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2,P3) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,3,CLASS, RET(__stdcall  CLASS::*)(P1,P2,P3) const, RET,P1,P2,P3>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2,P3) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,3,CLASS, RET(__thiscall CLASS::*)(P1,P2,P3) const, RET,P1,P2,P3>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2,P3,P4) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,4,CLASS, RET(__cdecl    CLASS::*)(P1,P2,P3,P4), RET,P1,P2,P3,P4>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2,P3,P4) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,4,CLASS, RET(__stdcall  CLASS::*)(P1,P2,P3,P4), RET,P1,P2,P3,P4>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2,P3,P4) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,4,CLASS, RET(__thiscall CLASS::*)(P1,P2,P3,P4), RET,P1,P2,P3,P4>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2,P3,P4) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,4,CLASS, RET(__cdecl    CLASS::*)(P1,P2,P3,P4) const, RET,P1,P2,P3,P4>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2,P3,P4) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,4,CLASS, RET(__stdcall  CLASS::*)(P1,P2,P3,P4) const, RET,P1,P2,P3,P4>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2,P3,P4) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,4,CLASS, RET(__thiscall CLASS::*)(P1,P2,P3,P4) const, RET,P1,P2,P3,P4>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2,P3,P4,P5) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,5,CLASS, RET(__cdecl    CLASS::*)(P1,P2,P3,P4,P5), RET,P1,P2,P3,P4,P5>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2,P3,P4,P5) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,5,CLASS, RET(__stdcall  CLASS::*)(P1,P2,P3,P4,P5), RET,P1,P2,P3,P4,P5>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2,P3,P4,P5) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,5,CLASS, RET(__thiscall CLASS::*)(P1,P2,P3,P4,P5), RET,P1,P2,P3,P4,P5>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2,P3,P4,P5) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,5,CLASS, RET(__cdecl    CLASS::*)(P1,P2,P3,P4,P5) const, RET,P1,P2,P3,P4,P5>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2,P3,P4,P5) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,5,CLASS, RET(__stdcall  CLASS::*)(P1,P2,P3,P4,P5) const, RET,P1,P2,P3,P4,P5>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2,P3,P4,P5) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,5,CLASS, RET(__thiscall CLASS::*)(P1,P2,P3,P4,P5) const, RET,P1,P2,P3,P4,P5>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2,P3,P4,P5,P6) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,6,CLASS, RET(__cdecl    CLASS::*)(P1,P2,P3,P4,P5,P6), RET,P1,P2,P3,P4,P5,P6>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2,P3,P4,P5,P6) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,6,CLASS, RET(__stdcall  CLASS::*)(P1,P2,P3,P4,P5,P6), RET,P1,P2,P3,P4,P5,P6>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2,P3,P4,P5,P6) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,6,CLASS, RET(__thiscall CLASS::*)(P1,P2,P3,P4,P5,P6), RET,P1,P2,P3,P4,P5,P6>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2,P3,P4,P5,P6) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,6,CLASS, RET(__cdecl    CLASS::*)(P1,P2,P3,P4,P5,P6) const, RET,P1,P2,P3,P4,P5,P6>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2,P3,P4,P5,P6) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,6,CLASS, RET(__stdcall  CLASS::*)(P1,P2,P3,P4,P5,P6) const, RET,P1,P2,P3,P4,P5,P6>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2,P3,P4,P5,P6) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,6,CLASS, RET(__thiscall CLASS::*)(P1,P2,P3,P4,P5,P6) const, RET,P1,P2,P3,P4,P5,P6>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,7,CLASS, RET(__cdecl    CLASS::*)(P1,P2,P3,P4,P5,P6,P7), RET,P1,P2,P3,P4,P5,P6,P7>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,7,CLASS, RET(__stdcall  CLASS::*)(P1,P2,P3,P4,P5,P6,P7), RET,P1,P2,P3,P4,P5,P6,P7>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,7,CLASS, RET(__thiscall CLASS::*)(P1,P2,P3,P4,P5,P6,P7), RET,P1,P2,P3,P4,P5,P6,P7>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,7,CLASS, RET(__cdecl    CLASS::*)(P1,P2,P3,P4,P5,P6,P7) const, RET,P1,P2,P3,P4,P5,P6,P7>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,7,CLASS, RET(__stdcall  CLASS::*)(P1,P2,P3,P4,P5,P6,P7) const, RET,P1,P2,P3,P4,P5,P6,P7>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,7,CLASS, RET(__thiscall CLASS::*)(P1,P2,P3,P4,P5,P6,P7) const, RET,P1,P2,P3,P4,P5,P6,P7>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8) )		{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,8,CLASS, RET(__cdecl    CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8), RET,P1,P2,P3,P4,P5,P6,P7,P8>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8) )		{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,8,CLASS, RET(__stdcall  CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8), RET,P1,P2,P3,P4,P5,P6,P7,P8>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8) )		{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,8,CLASS, RET(__thiscall CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8), RET,P1,P2,P3,P4,P5,P6,P7,P8>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,8,CLASS, RET(__cdecl    CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8) const, RET,P1,P2,P3,P4,P5,P6,P7,P8>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,8,CLASS, RET(__stdcall  CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8) const, RET,P1,P2,P3,P4,P5,P6,P7,P8>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,8,CLASS, RET(__thiscall CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8) const, RET,P1,P2,P3,P4,P5,P6,P7,P8>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8,P9) )		{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,9,CLASS, RET(__cdecl    CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8,P9), RET,P1,P2,P3,P4,P5,P6,P7,P8,P9>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8,P9) )		{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,9,CLASS, RET(__stdcall  CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8,P9), RET,P1,P2,P3,P4,P5,P6,P7,P8,P9>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8,P9) )		{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,9,CLASS, RET(__thiscall CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8,P9), RET,P1,P2,P3,P4,P5,P6,P7,P8,P9>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8,P9) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,9,CLASS, RET(__cdecl    CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8,P9) const, RET,P1,P2,P3,P4,P5,P6,P7,P8,P9>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8,P9) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,9,CLASS, RET(__stdcall  CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8,P9) const, RET,P1,P2,P3,P4,P5,P6,P7,P8,P9>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8,P9) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,9,CLASS, RET(__thiscall CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8,P9) const, RET,P1,P2,P3,P4,P5,P6,P7,P8,P9>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,10,CLASS, RET(__cdecl    CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10), RET,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,10,CLASS, RET(__stdcall  CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10), RET,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10>( pMeth ); }
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) )	{ return new gmFuncProxy<METHODE_TYPE,IS_NOT_CONST,10,CLASS, RET(__thiscall CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10), RET,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10>( pMeth ); }

template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10> inline gmProxy* _CreateMethodeProxy( RET (__cdecl    CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,10,CLASS, RET(__cdecl    CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) const, RET,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10>( pMeth );	}
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10> inline gmProxy* _CreateMethodeProxy( RET (__stdcall  CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,10,CLASS, RET(__stdcall  CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) const, RET,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10>( pMeth );	}
template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10> inline gmProxy* _CreateMethodeProxy( RET (__thiscall CLASS::*pMeth)(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) const )	{ return new gmFuncProxy<METHODE_TYPE,IS_CONST,10,CLASS, RET(__thiscall CLASS::*)(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) const, RET,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10>( pMeth );	}

template<class CLASS> inline gmProxy* CreateConstructorProxy()																																		{ return new gmFuncProxy<CONSTRUCTOR_TYPE,IS_NOT_CONST,0,   CLASS,void*,void>(NULL); }
template<class CLASS, typename P1> inline gmProxy* CreateConstructorProxy()																															{ return new gmFuncProxy<CONSTRUCTOR_TYPE,IS_NOT_CONST,1,   CLASS,void*,void,P1>(NULL); }
template<class CLASS, typename P1, typename P2> inline gmProxy* CreateConstructorProxy()																											{ return new gmFuncProxy<CONSTRUCTOR_TYPE,IS_NOT_CONST,2,   CLASS,void*,void,P1,P2>(NULL); }
template<class CLASS, typename P1, typename P2, typename P3> inline gmProxy* CreateConstructorProxy()																								{ return new gmFuncProxy<CONSTRUCTOR_TYPE,IS_NOT_CONST,3,   CLASS,void*,void,P1,P2,P3>(NULL); }
template<class CLASS, typename P1, typename P2, typename P3, typename P4> inline gmProxy* CreateConstructorProxy()																					{ return new gmFuncProxy<CONSTRUCTOR_TYPE,IS_NOT_CONST,4,   CLASS,void*,void,P1,P2,P3,P4>(NULL); }
template<class CLASS, typename P1, typename P2, typename P3, typename P4, typename P5> inline gmProxy* CreateConstructorProxy()																		{ return new gmFuncProxy<CONSTRUCTOR_TYPE,IS_NOT_CONST,5,   CLASS,void*,void,P1,P2,P3,P4,P5>(NULL); }
template<class CLASS, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6> inline gmProxy* CreateConstructorProxy()														{ return new gmFuncProxy<CONSTRUCTOR_TYPE,IS_NOT_CONST,6,   CLASS,void*,void,P1,P2,P3,P4,P5,P6>(NULL); }
template<class CLASS, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7> inline gmProxy* CreateConstructorProxy()											{ return new gmFuncProxy<CONSTRUCTOR_TYPE,IS_NOT_CONST,7,   CLASS,void*,void,P1,P2,P3,P4,P5,P6,P7>(NULL); }
template<class CLASS, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8> inline gmProxy* CreateConstructorProxy()								{ return new gmFuncProxy<CONSTRUCTOR_TYPE,IS_NOT_CONST,8,   CLASS,void*,void,P1,P2,P3,P4,P5,P6,P7,P8>(NULL); }
template<class CLASS, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9> inline gmProxy* CreateConstructorProxy()					{ return new gmFuncProxy<CONSTRUCTOR_TYPE,IS_NOT_CONST,9,   CLASS,void*,void,P1,P2,P3,P4,P5,P6,P7,P8,P9>(NULL); }
template<class CLASS, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10> inline gmProxy* CreateConstructorProxy()	{ return new gmFuncProxy<CONSTRUCTOR_TYPE,IS_NOT_CONST,10,  CLASS,void*,void,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10>(NULL); }

template<typename RET> static inline gmProxy* _CreateOperatorProxy( RET (__cdecl* pOp)() )		{ return new gmFuncProxy<FUNCTION_OPERATOR_TYPE,IS_NOT_CONST,0,_DUMMY_, RET(__cdecl*)(), RET>( pOp ); }
template<typename RET> static inline gmProxy* _CreateOperatorProxy( RET (__stdcall* pOp)() )	{ return new gmFuncProxy<FUNCTION_OPERATOR_TYPE,IS_NOT_CONST,0,_DUMMY_, RET(__stdcall*)(), RET>( pOp ); }

template<typename RET, typename P1> static inline gmProxy* _CreateOperatorProxy( RET (__cdecl* pOp)(P1) )		{ return new gmFuncProxy<FUNCTION_OPERATOR_TYPE,IS_NOT_CONST,1,_DUMMY_, RET(__cdecl*)(P1), RET,P1>( pOp ); }
template<typename RET, typename P1> static inline gmProxy* _CreateOperatorProxy( RET (__stdcall* pOp)(P1) )		{ return new gmFuncProxy<FUNCTION_OPERATOR_TYPE,IS_NOT_CONST,1,_DUMMY_, RET(__stdcall*)(P1), RET,P1>( pOp ); }

template<typename RET, typename P1, typename P2> static inline gmProxy* _CreateOperatorProxy( RET (__cdecl* pOp)(P1,P2) )		{ return new gmFuncProxy<FUNCTION_OPERATOR_TYPE,IS_NOT_CONST,2,_DUMMY_, RET(__cdecl*)(P1,P2), RET,P1,P2>( pOp ); }
template<typename RET, typename P1, typename P2> static inline gmProxy* _CreateOperatorProxy( RET (__stdcall* pOp)(P1,P2) )		{ return new gmFuncProxy<FUNCTION_OPERATOR_TYPE,IS_NOT_CONST,2,_DUMMY_, RET(__stdcall*)(P1,P2), RET,P1,P2>( pOp ); }

template<class CLASS, typename RET> inline gmProxy* _CreateOperatorProxy( RET (__cdecl    CLASS::*pOp)() )	{ return new gmFuncProxy<METHODE_OPERATOR_TYPE,IS_NOT_CONST,0,CLASS, RET(__cdecl    CLASS::*)(), RET>( pOp ); }
template<class CLASS, typename RET> inline gmProxy* _CreateOperatorProxy( RET (__stdcall  CLASS::*pOp)() )	{ return new gmFuncProxy<METHODE_OPERATOR_TYPE,IS_NOT_CONST,0,CLASS, RET(__stdcall  CLASS::*)(), RET>( pOp ); }
template<class CLASS, typename RET> inline gmProxy* _CreateOperatorProxy( RET (__thiscall CLASS::*pOp)() )	{ return new gmFuncProxy<METHODE_OPERATOR_TYPE,IS_NOT_CONST,0,CLASS, RET(__thiscall CLASS::*)(), RET>( pOp ); }

template<class CLASS, typename RET> inline gmProxy* _CreateOperatorProxy( RET (__cdecl    CLASS::*pOp)() const )	{ return new gmFuncProxy<METHODE_OPERATOR_TYPE,IS_CONST,0,CLASS, RET(__cdecl    CLASS::*)() const, RET>( pOp ); }
template<class CLASS, typename RET> inline gmProxy* _CreateOperatorProxy( RET (__stdcall  CLASS::*pOp)() const )	{ return new gmFuncProxy<METHODE_OPERATOR_TYPE,IS_CONST,0,CLASS, RET(__stdcall  CLASS::*)() const, RET>( pOp ); }
template<class CLASS, typename RET> inline gmProxy* _CreateOperatorProxy( RET (__thiscall CLASS::*pOp)() const )	{ return new gmFuncProxy<METHODE_OPERATOR_TYPE,IS_CONST,0,CLASS, RET(__thiscall CLASS::*)() const, RET>( pOp ); }

template<class CLASS, typename RET, typename P1> inline gmProxy* _CreateOperatorProxy( RET (__cdecl    CLASS::*pOp)(P1) )	{ return new gmFuncProxy<METHODE_OPERATOR_TYPE,IS_NOT_CONST,1,CLASS, RET(__cdecl    CLASS::*)(P1), RET,P1>( pOp ); }
template<class CLASS, typename RET, typename P1> inline gmProxy* _CreateOperatorProxy( RET (__stdcall  CLASS::*pOp)(P1) )	{ return new gmFuncProxy<METHODE_OPERATOR_TYPE,IS_NOT_CONST,1,CLASS, RET(__stdcall  CLASS::*)(P1), RET,P1>( pOp ); }
template<class CLASS, typename RET, typename P1> inline gmProxy* _CreateOperatorProxy( RET (__thiscall CLASS::*pOp)(P1) )	{ return new gmFuncProxy<METHODE_OPERATOR_TYPE,IS_NOT_CONST,1,CLASS, RET(__thiscall CLASS::*)(P1), RET,P1>( pOp ); }

template<class CLASS, typename RET, typename P1> inline gmProxy* _CreateOperatorProxy( RET (__cdecl    CLASS::*pOp)(P1) const )	{ return new gmFuncProxy<METHODE_OPERATOR_TYPE,IS_CONST,1,CLASS, RET(__cdecl    CLASS::*)(P1) const, RET,P1>( pOp ); }
template<class CLASS, typename RET, typename P1> inline gmProxy* _CreateOperatorProxy( RET (__stdcall  CLASS::*pOp)(P1) const )	{ return new gmFuncProxy<METHODE_OPERATOR_TYPE,IS_CONST,1,CLASS, RET(__stdcall  CLASS::*)(P1) const, RET,P1>( pOp ); }
template<class CLASS, typename RET, typename P1> inline gmProxy* _CreateOperatorProxy( RET (__thiscall CLASS::*pOp)(P1) const )	{ return new gmFuncProxy<METHODE_OPERATOR_TYPE,IS_CONST,1,CLASS, RET(__thiscall CLASS::*)(P1) const, RET,P1>( pOp ); }

#pragma warning( default: 4127 )

#endif